<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>CRUD</title>
  </head>
  <body>
    <script type="text/javascript">
      var users = [
        {
          id: 1,
          name: "Vivek",
          email: "vivek@abc.com",
          phone: "8989389333",
          address: "Singapore",
        },
        {
          id: 2,
          name: "Dev",
          email: "dev@abc.com",
          phone: "866u389333",
          address: "India",
        },
        {
          id: 3,
          name: "Ameer",
          email: "ameer@abc.com",
          phone: "877779333",
          address: "Asia",
        },
      ];
      var selectedId = 0; // 0 means new record

      resetForm = function () {
        document.getElementById("name").value = "";
        document.getElementById("email").value = "";
        document.getElementById("phone").value = "";
        document.getElementById("address").value = "";
        document.getElementById("addButton").value = "Add";
        selectedId = 0; //this indicate new Record
      };
      update = function (id) {
        var temp = users.filter((item) => item.id == id);
        if (temp.length > 0) {
          let record = temp[0];
          selectedId = record.id; //selected record Id
          document.getElementById("name").value = record.name;
          document.getElementById("email").value = record.email;
          document.getElementById("phone").value = record.phone;
          document.getElementById("address").value = record.address;
          document.getElementById("addButton").value = "Update";
        }
      };
      addOrUpdateUser = function(){
      	var name = document.getElementById('name').value;
      	var email = document.getElementById('email').value;
      	var phone = document.getElementById('phone').value;
      	var address = document.getElementById('address').value;

      	if(selectedId == 0){
      		var len = users.length;
      		if(len > 0){
      			let lastId = users[len - 1].id
      			var id =lastId +1
      		}else{
      			var id = 1;
      		}
      		users.push({id,name,email,phone,address});
      	}else{
      		var id = selectedId; //selected record Id
      		var array = users.filter((item) => (item.id == id));
      		array[0].name = name;
      		array[0].email = email;
      		array[0].address = address;
      		array[0].phone = phone;
      	}
      	display();
      	resetForm();
      }

      deleteUser = function (id) {

       console.log(" id::",+ id);
        users = users.filter((item) => item.id != id);
        display();
      };
      display = function () {
        //JSON.stringify(s);
        console.log(users.length);
        const result= document.getElementById("result");
        result.innerHTML = "";

        for (var i = 0; i < users.length; i++) {
          let id = users[i].id;
          const newRecord = document.createElement("tr");

          const newId = document.createElement("td");
          newId.innerHTML = users[i].id;

          const newName = document.createElement("td");
          newName.innerHTML = users[i].name;

          const newEmail = document.createElement("td");
          newEmail.innerHTML = users[i].email;

          const newPhone = document.createElement("td");
          newPhone.innerHTML = users[i].phone;

          const newAddress = document.createElement("td");
          newAddress.innerHTML = users[i].address;

          newRecord.appendChild(newId);
          newRecord.appendChild(newName);
          newRecord.appendChild(newEmail);
          newRecord.appendChild(newPhone);
          newRecord.appendChild(newAddress);

          const newDeleteButton = document.createElement("td");

          const newButton = document.createElement("BUTTON");
          newButton.innerHTML = "delete";
          newButton.onclick = function (e) {
            e.preventDefault();
            deleteUser(id);
          };
          newDeleteButton.appendChild(newButton);

          const newEditButton = document.createElement("td");
          const newEButton = document.createElement("BUTTON");
          newEButton.innerHTML = "edit";
          newEButton.onclick = function (e) {
            e.preventDefault();
            update(id);
          };
          newEditButton.appendChild(newEButton);

          newRecord.appendChild(newEditButton);
          newRecord.appendChild(newDeleteButton);

          result.appendChild(newRecord);
        }
      };
      display();
    </script>
    <div>
      <form name="user" id="user">
        <input type="text" name="Name" placeholder="Name" id="name" /><br />
        <br />
        <input type="email" name="email" placeholder="Email" id="email" />
        <br /><br />
        <input type="number" name="phone" placeholder="phone" id="phone" />
        <br /><br />
        <input type="text" name="address" placeholder="Address" id="address" />
        <br /><br />
        <input onclick="addOrUpdateUser()" type="button" name="" value="Add" /> |
        <input onclick="deleteUser()" type="button" name="" value="Delete" /> |

        <input onclick="display()" type="button" name="" value="Show All" />
      </form>
       
      <h4>Result</h4>
      <br />
      <br />
      <table>
        <thead>
          <tr>
            <th>#</th>
            <th>Name</th>
            <th>Email</th>
            <th>Phone</th>
            <th>Address</th>
            <th>Edit</th>
            <th>Delete</th>
          </tr>
        </thead>
        <tbody id="result">
          <script type="text/javascript">
            display();
          </script>
        </tbody>
      </table>
      <br /> 
    </div>
  </body>
</html>
